### Function

# GLib utf8_to_ucs4

since: 2.0

#### Declaration

    gunichar*
    g_utf8_to_ucs4 (
      const gchar* str,
      glong len,
      glong* items_read,
      glong* items_written,
      GError** error
    )

#### Description

Convert a string from UTF-8 to a 32-bit fixed width representation as UCS-4. A trailing 0 character will be added to the string after the converted text.

Available since: 2.0

#### Parameters

`str`

  Type: `const gchar*`

  A UTF-8 encoded string.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`len`

  Type: `glong`

  The maximum length of `str` to use, in bytes. If `len` < 0, then the string is nul-terminated.

`items_read`

  Type: `glong*`

  Location to store number of bytes read, or `NULL`. If `NULL`, then `G_CONVERT_ERROR_PARTIAL_INPUT` will be returned in case `str` contains a trailing partial character. If an error occurs then the index of the invalid input is stored here.

  The argument will be set by the function.
  The argument can be `NULL`.

`items_written`

  Type: `glong*`

  Location to store number of characters written or `NULL`. The value here stored does not include the trailing 0 character.

  The argument will be set by the function.
  The argument can be `NULL`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gunichar*`

A pointer to a newly allocated UCS-4 string. This value must be freed with g_free(). If an error occurs, `NULL` will be returned and `error` set.

The caller of the function takes ownership of the data, and is responsible for freeing it.